'$INCLUDE: 'gcontrol.bi'


CLS
IF IsXMSInstalled <> -1 THEN PRINT "No XMS": END        'check if XMS is installed
IF IsEMMInstalled <> -1 THEN PRINT "No EMS": END        'check if EMS is installed

Set800x600 16
'Set320x200 24
'Set640x480 16

temp = InitGCON%(0, mem&)               'Initializes G-Control with no controls saving

IF temp = 1 THEN        'InitGCON returns 1  = insufficient XMS memory
  resetscreen
  PRINT "Insufficient XMS memory."
  END
END IF


future.mouseoff
future.fillbox 0, 0, 800, 600, RGB2Color(200, 200, 200)

Button1 = Button.Create("This is a button", 50, 50, 200, 30, 0, RGB2Color(200, 200, 200))
Button2 = Button.Create("Set Caption like this", 260, 50, 200, 30, 0, RGB2Color(200, 200, 200))

future.mouseoff
future.box 50, 100, 200, 450, 0

future.print 70, 105, "Button Events", 0, RGB2Color(200, 200, 200)
future.mouseon

DO
  Updatekey
  UpdateMouse
  
  Click = Button.click(Button1)
  future.print 60, 130, "Click:" + STR$(Click), 0, RGB2Color(200, 200, 200)

  Keypress = Button.KeyPress(Button1, KeyChar$)
  future.print 60, 170, "Keypress:" + STR$(Keypress), 0, RGB2Color(200, 200, 200)
  future.print 80, 190, "Char: " + KeyChar$, 0, RGB2Color(200, 200, 200)

  Mousedown = Button.MouseDown(Button1, Button)
  future.print 60, 210, "MouseDown:" + STR$(Mousedown), 0, RGB2Color(200, 200, 200)
  future.print 80, 230, "Button:" + STR$(Button), 0, RGB2Color(200, 200, 200)

  Mouseup = Button.MouseUp(Button1, Button)
  future.print 60, 250, "MouseUp:" + STR$(Mouseup), 0, RGB2Color(200, 200, 200)
  future.print 80, 270, "Button:" + STR$(Button), 0, RGB2Color(200, 200, 200)

  MouseOver = Button.MouseOver(Button1, mx, my)
  future.print 60, 290, "MouseOver:" + STR$(MouseOver), 0, RGB2Color(200, 200, 200)
  future.print 80, 310, "X:" + STR$(mx) + "   ", 0, RGB2Color(200, 200, 200)
  future.print 80, 330, "Y:" + STR$(my) + "   ", 0, RGB2Color(200, 200, 200)

  GotFocus = Button.GotFocus%(Button1)
  future.print 60, 350, "GotFocus:" + STR$(GotFocus), 0, RGB2Color(200, 200, 200)

  LostFocus = Button.LostFocus(Button1)
  future.print 60, 370, "LostFocus:" + STR$(LostFocus), 0, RGB2Color(200, 200, 200)
  

  Button.DoEvent Button1


  IF Button.click(Button2) THEN
    Button.SetCaption Button1, Button.Caption$(Button2)
  END IF
  Button.DoEvent Button2

LOOP UNTIL UnivKey = CHR$(27)   'Use UnivKey instead of INKEY$

resetscreen     'reset screen to previous mode
endGCON         'extremely important when you end your program

