'$INCLUDE: 'gcontrol.bi'


CLS
IF IsXMSInstalled <> -1 THEN PRINT "No XMS": END        'check if XMS is installed
IF IsEMMInstalled <> -1 THEN PRINT "No EMS": END        'check if EMS is installed


Set800x600 16
'Set320x200 24
'Set640x480 16

temp = InitGCON%(0, mem&)               'Initializes G-Control with no controls saving

IF temp = 1 THEN        'InitGCON returns 1  = insufficient XMS memory
  ReSetScreen
  PRINT "Insufficient XMS memory."
  END
END IF


Future.MouseOff
Future.FILLBOX 0, 0, 800, 600, RGB2Color(200, 200, 200)

Check1 = CheckBox.Create("Check 1", 100, 40, 0, RGB2Color(200, 200, 200), 0, RGB2Color(255, 255, 255))
check2 = CheckBox.Create("Check 2", 300, 40, 0, RGB2Color(200, 200, 200), 0, RGB2Color(255, 255, 255))

Future.MouseOff
Future.PRINT 100, 70, "You may press spacebar to toggle values.", 0, -1

Future.BOX 50, 100, 200, 450, 0

Future.PRINT 70, 105, "Check1 Events", 0, RGB2Color(200, 200, 200)
Future.MouseOn

DO
  
  Updatekey
  UpdateMouse

  IF CheckBox.Click(Check1) THEN
        IF CheckBox.Value(Check1) = 1 THEN
                CheckBox.SetCaption Check1, "Check 1 is checked"
        ELSE
                CheckBox.SetCaption Check1, "Check 1"
        END IF
        
 END IF
 Click = CheckBox.Click(Check1)
 Future.PRINT 60, 130, "Click:" + STR$(Click), 0, RGB2Color(200, 200, 200)

  Keypress = CheckBox.KeyPress(Check1, KeyChar$)
  Future.PRINT 60, 170, "Keypress:" + STR$(Keypress), 0, RGB2Color(200, 200, 200)
  Future.PRINT 80, 190, "Char: " + KeyChar$, 0, RGB2Color(200, 200, 200)

  Mousedown = CheckBox.MouseDown(Check1, Button)
  Future.PRINT 60, 210, "MouseDown:" + STR$(Mousedown), 0, RGB2Color(200, 200, 200)
  Future.PRINT 80, 230, "Button:" + STR$(Button), 0, RGB2Color(200, 200, 200)

  Mouseup = CheckBox.MouseUp(Check1, Button)
  Future.PRINT 60, 250, "MouseUp:" + STR$(Mouseup), 0, RGB2Color(200, 200, 200)
  Future.PRINT 80, 270, "Button:" + STR$(Button), 0, RGB2Color(200, 200, 200)

  MouseOver = CheckBox.MouseOver(Check1, mx, my)
  Future.PRINT 60, 290, "MouseOver:" + STR$(MouseOver), 0, RGB2Color(200, 200, 200)
  Future.PRINT 80, 310, "X:" + STR$(mx) + "   ", 0, RGB2Color(200, 200, 200)
  Future.PRINT 80, 330, "Y:" + STR$(my) + "   ", 0, RGB2Color(200, 200, 200)

  
  GotFocus = CheckBox.GotFocus%(Check1)
  Future.PRINT 60, 350, "GotFocus:" + STR$(GotFocus), 0, RGB2Color(200, 200, 200)

  LostFocus = CheckBox.LostFocus(Check1)
  Future.PRINT 60, 370, "LostFocus:" + STR$(LostFocus), 0, RGB2Color(200, 200, 200)


 CheckBox.DoEvent Check1
 CheckBox.DoEvent check2

LOOP UNTIL UnivKey = CHR$(27)   'Use UnivKey instead of INKEY$

ReSetScreen     'reset screen to previous mode
endGCON         'extremely important when you end your program





