DECLARE FUNCTION RestoreControls% (SaveNumber%)
DECLARE FUNCTION DelTempFiles% ()
DECLARE FUNCTION SaveControls% (SaveNumber%)
DECLARE SUB SetLongEvent (ControlID%, Index%, Value&)
DECLARE SUB XMSSpaceit (Handle%, TotalBytes&)
DECLARE FUNCTION TempDir$ ()
DECLARE FUNCTION InitGCON% (MaxSave%, XMSMemNeeded&)
DECLARE FUNCTION BlinkSpeed! ()
DECLARE FUNCTION DblSpeed! ()
DECLARE FUNCTION MouseX% ()
DECLARE FUNCTION MouseY% ()
DECLARE FUNCTION MouseB% ()
DECLARE FUNCTION LongEvent& (ControlID%, Index%)
DECLARE FUNCTION FreeListHandle% ()
DECLARE FUNCTION XMS4.GetItem$ (Handle%, Index&)
DECLARE FUNCTION XMS4.Ubound& (AllocatedSize&)
'Future.Library v3.50
'by Jorden Chamid and Michael Rye Sorensen

'*** SVGA Mouse ***
DECLARE SUB Future.updatemouse ALIAS "SVGAupdatemouse" ()
DECLARE SUB SetMouseRange (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%)
DECLARE SUB SetLocation (BYVAL X%, BYVAL y%)
DECLARE SUB SetMouseMaskColor ALIAS "SVGAmousemask" (BYVAL C&)
DECLARE SUB Future.MouseShape ALIAS "SVGAmouseShape" (BYVAL Offset%, BYVAL Segment%)
DECLARE SUB Future.ResetMouseShape ALIAS "MouseCursorGenerator" ()
DECLARE SUB future.mouseoff ALIAS "SVGAmouseoff" ()
DECLARE SUB future.mouseon ALIAS "SVGAmouseon" ()
DECLARE FUNCTION Future.MouseB% ALIAS "SVGAmouseB" ()
DECLARE FUNCTION Future.MouseY% ALIAS "SVGAmouseY" ()
DECLARE FUNCTION Future.MouseX% ALIAS "SVGAmouseX" ()
DECLARE SUB SetMouseSensitivity (BYVAL H%, BYVAL V%)
'*** Graphics ***
DECLARE SUB Set320x200 (B%)
DECLARE SUB Set320x240 (B%)
DECLARE SUB Set320x400 (B%)
DECLARE SUB Set320x480 (B%)
DECLARE SUB Set400x300 (B%)
DECLARE SUB Set512x384 (B%)
DECLARE SUB Set640x350 (B%)
DECLARE SUB Set640x400 (B%)
DECLARE SUB Set640x480 (B%)
DECLARE SUB Set720x480 (B%)
DECLARE SUB Set720x576 (B%)
DECLARE SUB Set800x600 (B%)
DECLARE SUB Set1024x768 (B%)
DECLARE SUB Set1152x864 (B%)
DECLARE SUB Set1280x960 (B%)
DECLARE SUB Set1280x1024 (B%)
DECLARE SUB Set1600x1200 (B%)
DECLARE SUB Set1920x1080 (B%)
DECLARE SUB Set1920x1200 (B%)
DECLARE SUB Set1920x1440 (B%)
DECLARE SUB Set2048x1536 (B%)
DECLARE SUB SetScreenMode (XRes%, YRes%, Bits%)
DECLARE SUB resetscreen
DECLARE FUNCTION Pages% ()
DECLARE FUNCTION IsVESA%
DECLARE FUNCTION VideoMemory&
DECLARE SUB ViewPage (BYVAL p%)
DECLARE SUB SetFrameBuffer ALIAS "SVGAframesize" (BYVAL X%, BYVAL y%)
DECLARE SUB SetMaskColor (BYVAL C&)
DECLARE SUB SetPage (BYVAL p%)
DECLARE SUB SetViewPort ALIAS "SVGAviewport" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%)
DECLARE FUNCTION RGB2Color& (BYVAL R%, BYVAL G%, BYVAL B%)
DECLARE SUB Color2RGB (BYVAL C&, R%, G%, B%)
DECLARE FUNCTION Future.Version$ ()
DECLARE FUNCTION SizeOf& ALIAS "SVGAsizeof" (BYVAL X%, BYVAL y%)
DECLARE FUNCTION Future.ModeList$ (I%)
DECLARE FUNCTION Future.POINT ALIAS "SVGApoint" (BYVAL X%, BYVAL y%)
DECLARE SUB Future.ScrollUD ALIAS "SVGAscrollud" (BYVAL pixels%)
DECLARE SUB Future.ScrollLR ALIAS "SVGAscrolllr" (BYVAL pixels%)
DECLARE SUB Future.PSET ALIAS "SVGApset" (BYVAL X%, BYVAL y%, BYVAL C&)
DECLARE SUB Future.CLS ALIAS "SVGAcls" (BYVAL C&)
DECLARE SUB future.fillbox ALIAS "SVGAfillbox" (BYVAL X%, BYVAL y%, BYVAL X1%, BYVAL Y1%, BYVAL C&)
DECLARE SUB future.box ALIAS "SVGAbox" (BYVAL X%, BYVAL y%, BYVAL X1%, BYVAL Y1%, BYVAL C&)
DECLARE SUB future.LINE ALIAS "SVGAline" (BYVAL X%, BYVAL y%, BYVAL X1%, BYVAL Y1%, BYVAL C&, BYVAL Bitscan%)
DECLARE SUB Future.CIRCLE ALIAS "SVGAcircle" (BYVAL CX%, BYVAL CY%, BYVAL Radius%, BYVAL C&)
DECLARE SUB Future.FILLCIRCLE ALIAS "SVGAfillcircle" (BYVAL CX%, BYVAL CY%, BYVAL Radius%, BYVAL C&)
DECLARE SUB Future.HLINE ALIAS "SVGAhline" (BYVAL y%, BYVAL X1%, BYVAL x2%, BYVAL C&)
DECLARE SUB Future.TRIFILL ALIAS "SVGAtrifill" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%, BYVAL X3%, BYVAL Y3%, BYVAL C&)
DECLARE SUB Future.TRIGOUR ALIAS "SVGAtrigour" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%, BYVAL X3%, BYVAL Y3%, BYVAL C1&, BYVAL C2&, BYVAL C3&)
DECLARE SUB Future.TRITEXT (X1%, Y1%, x2%, y2%, X3%, Y3%, U1%, V1%, U2%, V2%, U3%, V3%, Array() AS ANY)
DECLARE SUB Future.ROTATE (X%, y%, Angle%, Scale!, Array() AS ANY)
DECLARE SUB Future.ROTATEB (X%, y%, Angle%, Scale!, Array() AS ANY)
DECLARE SUB Future.SNAPSHOT (FileName$)
DECLARE SUB Future.GET (X%, y%, X1%, Y1%, Array() AS ANY)
DECLARE SUB Future.PUT (X%, y%, Array() AS ANY)
DECLARE SUB future.print (X%, y%, t$, C&, B&)
DECLARE SUB Future.LoadGIF (FileName$, Xpos%, Ypos%)
TYPE TGIFInfo
       Filehandle AS INTEGER
       X AS INTEGER
       y AS INTEGER
       BackgroundColor AS INTEGER
       Pal AS INTEGER
       NColor AS INTEGER
       GlobalCLUT AS STRING * 768
       loopit AS INTEGER
       StartFramePos AS LONG
       FramePos AS LONG
       EOFile AS INTEGER
END TYPE
DECLARE SUB Future.OpenAGif (FileName$, GifHandle AS TGIFInfo)
DECLARE SUB Future.CloseAGif (GifHandle AS TGIFInfo)
DECLARE SUB Future.putAGif (Xpos%, Ypos%, GifHandle AS TGIFInfo)
DECLARE SUB Future.LoadBMP (FileName$, Xpos%, Ypos%)
DECLARE SUB Future.LoadPCX (FileName$, Xpos%, Ypos%)
DECLARE SUB Future.LoadFONT (FileName$)
DECLARE SUB SetFont ALIAS "SVGAsetfont" (BYVAL Mode%)
DECLARE SUB LoadGIF (A$)
DECLARE SUB LoadPCX (A$)
DECLARE SUB LoadBMP (A$)

DECLARE SUB LoadScreen (FileName$)
DECLARE SUB SaveScreen (FileName$)
'*** Key handling ***
DECLARE SUB StickStatus (JoyX%, JoyY%, But1%, But2%, But3%)
DECLARE SUB LockKeys (Nr%, State%)
DECLARE SUB DisableBreak
DECLARE SUB ClearKeyBuffer
DECLARE FUNCTION GetKey% (BYVAL KeyCode%)
DECLARE SUB KBHon ()
DECLARE SUB KBHoff ()
'*** Misc. ***
DECLARE FUNCTION Timer2& ()
DECLARE SUB StartTIMER ()
DECLARE SUB StopTimer ()
DECLARE SUB SetTIMERspeed (BYVAL Frequency%)
DECLARE SUB ResetCounter ()
DECLARE FUNCTION ReadCounter& ()
DECLARE SUB StartSubTIMER (BYVAL TimerNr%)
DECLARE SUB StopSubTIMER (BYVAL TimerNr%)
DECLARE SUB SetSubTIMERspeed (BYVAL Frequency%, BYVAL TimerNr%)
DECLARE SUB ResetSubCounter (BYVAL TimerNr%)
DECLARE FUNCTION ReadSubCounter& (BYVAL TimerNr%)
'*** EMS ***
DECLARE SUB Future.EMSPut (X%, y%, Handle%)
DECLARE SUB Future.EMSGet (X%, y%, X1%, Y1%, Handle%)
DECLARE SUB Future.EMSPutx (Tx%, Ty%, Handle%, Sx%, Sy%, Sx1%, Sy1%)
DECLARE SUB Future.EMSGetx (Tx%, Ty%, Handle%, Sx%, Sy%, Sx1%, Sy1%)
DECLARE SUB Future.EMStoFile (FileName$, Handle%, fileStartpos&, EMSStartpos&, BytesTomove&)
DECLARE SUB Future.FiletoEMS (FileName$, Handle%, fileStartpos&, EMSStartpos&, BytesTomove&)
DECLARE FUNCTION GetEMMVersion! ()
DECLARE FUNCTION AllExpMem% (Bytes&)
DECLARE SUB DeallExpMem (Handle%)
DECLARE SUB FreeAllExpMem ()
DECLARE FUNCTION PageFrameAddr% ()
DECLARE FUNCTION TotalPages% ()
DECLARE FUNCTION UnallocatedPages% ()
DECLARE FUNCTION IsEMMInstalled% ()
DECLARE SUB SetEMSpage (BYVAL EMSPageNumber%)
DECLARE SUB CopyEMSpage (BYVAL tEMSPageNumber%, BYVAL sEMSPageNumber%)
'*** XMS ***
DECLARE SUB Future.XMSget (X%, y%, X1%, Y1%, XMShandle%)
DECLARE SUB Future.XMSput (X%, y%, XMShandle%)
DECLARE FUNCTION IsXMSInstalled% ()
DECLARE FUNCTION AllocateXMS% (BYVAL Bytes&)
DECLARE SUB DeallocateXMS (BYVAL Handle%)
DECLARE FUNCTION FreeXMSmemory& ()
DECLARE SUB MoveXMS (BYVAL SourceHandle%, BYVAL SourceOffset&, BYVAL DestHandle%, BYVAL DestOffset&, BYVAL Bytes&)
DECLARE SUB MoveToXMS (BYVAL Handle%, BYVAL Segment%, BYVAL Offset%, BYVAL Bytes&, BYVAL XMSOffset&)
DECLARE SUB MoveFromXMS (BYVAL Handle%, BYVAL Segment%, BYVAL Offset%, BYVAL Bytes&, BYVAL XMSOffset&)
DECLARE SUB Future.DefineXMSArray (X%, y%, XMShandle%)
DECLARE SUB Future.XMSArrayGet (X%, y%, XMShandle%, Index%)
DECLARE SUB Future.XMSArrayPut (X%, y%, XMShandle%, Index%)


DEFINT A-Z



DECLARE FUNCTION StrProp$ (ControlID%, Index%)
DECLARE SUB SetLongProp (ControlID%, Index%, Value&)
DECLARE SUB SetIntProp (ControlID%, Index%, Value%)
DECLARE SUB SetIntEvent (ControlID%, Index%, Value%)
DECLARE FUNCTION UnivSwitch% (ControlID%, Index%)

DECLARE FUNCTION ActiveControl% ()
DECLARE SUB SetActiveControl (ControlID%)
DECLARE FUNCTION IntEvent% (ControlID%, Index%)
DECLARE FUNCTION IntProp% (ControlID%, Index%)
DECLARE FUNCTION LongProp& (ControlID%, Index%)


DECLARE FUNCTION UnivKey$ ()
DECLARE FUNCTION Button.KeyPress% (ControlID%, KeyChar$)
DECLARE FUNCTION Button.MouseUp% (ControlID%, Button%)
DECLARE FUNCTION Button.LostFocus% (ControlID%)
DECLARE FUNCTION Button.GotFocus% (ControlID%)
DECLARE FUNCTION Button.Create% (Caption$, Left%, Top%, Width.%, Height%, ForeColor&, BackColor&)
DECLARE FUNCTION Button.MouseDown% (ControlID%, Button%)
DECLARE FUNCTION Button.click% (ControlID%)
DECLARE FUNCTION Button.MouseOver% (ControlID%, X%, y%)


'XMS Array routines for 512 bytes string
DECLARE FUNCTION XMS512.GetItem$ (Handle%, Index&)
DECLARE SUB XMS512.PutItem (Handle%, Index&, charstr$)
DECLARE FUNCTION XMS512.Ubound& (AllocatedSize&)

'XMS Array routines for 256 bytes string
DECLARE SUB XMS256.PutItem (Handle%, Index&, charstr$)
DECLARE FUNCTION XMS256.GetItem$ (Handle%, Index&)
DECLARE FUNCTION XMS256.Ubound& (AllocatedSize&)

'XMS Array routines for 128 bytes string
DECLARE FUNCTION XMS128.GetItem$ (Handle%, Index&)
DECLARE SUB XMS128.PutItem (Handle%, Index&, charstr$)
DECLARE FUNCTION XMS128.Ubound& (AllocatedSize&)

'XMS Array routines for 64 bytes string
DECLARE FUNCTION XMS64.GetItem$ (Handle%, Index&)
DECLARE SUB XMS64.PutItem (Handle%, Index&, charstr$)
DECLARE FUNCTION XMS64.Ubound& (AllocatedSize&)

'XMS Array routines for 32 bytes string
DECLARE FUNCTION XMS32.GetItem$ (Handle%, Index&)
DECLARE SUB XMS32.PutItem (Handle%, Index&, charstr$)
DECLARE FUNCTION XMS32.Ubound& (AllocatedSize&)


'----- Two Dimensional XMS Array routines

TYPE XMS2D
  Handle AS INTEGER
  xIndex AS INTEGER
  yIndex AS LONG
  xIndextotal AS LONG
  size AS INTEGER
END TYPE


DECLARE FUNCTION XMS2D.Allocate% (Handle AS ANY, xIndex%, yIndex&, size%)
DECLARE FUNCTION XMS2D.GetSize& (xIndex%, yIndex&, size%)
DECLARE FUNCTION XMS2D.GetItem$ (Handle AS ANY, xIndex%, yIndex&)
DECLARE SUB XMS2D.PutItem (Handle AS ANY, xIndex%, yIndex&, charstr$)

DIM SHARED VQBIntProp%(150, 30), VQBLongProp&(150, 15), VQBStrProp AS XMS2D, VQBIntEvent%(150, 30), VQBLongEvent&(150, 10), VQBUnivSwitch%(10, 5)
DIM SHARED VQBActiveControl%, VQBUnivKey$, VQBListHandles%(50)
DIM SHARED CursorBlinkSpeed!, DblClickSpeed!, VQBMY%, VQBMX%, VQBMB%
DIM SHARED SaveHandle%, MaxSaveCon%, IntPropLen&, LongPropLen&, StrPropLen&, IntEventLen&, LongEventLen&, UnivLen&
DIM SHARED IntPropPos&, LongPropPos&, StrPropPos&, IntEventPos&, LongEventPos&, UnivPos&
DIM SHARED VQBTempDir$

FUNCTION ActiveControl%
  ActiveControl% = VQBActiveControl%
END FUNCTION

FUNCTION BlinkSpeed!
   BlinkSpeed! = CursorBlinkSpeed!
END FUNCTION

FUNCTION DblSpeed!
  DblSpeed! = DblClickSpeed!
END FUNCTION

SUB Delay (Counter#)
tmpCounter# = TIMER + Counter#
DO
  IF TIMER >= tmpCounter# THEN EXIT DO
LOOP

END SUB

FUNCTION DelTempFiles%
        ON LOCAL ERROR GOTO errHandler

        KILL TempDir$ + "INTPR*.TMP"
        KILL TempDir$ + "LONGP*.TMP"
        KILL TempDir$ + "INTEV*.TMP"
        KILL TempDir$ + "LONGE*.TMP"
        KILL TempDir$ + "UNIV*.TMP"

        EXIT FUNCTION

errHandler:       
        IF ERR = 53 THEN
          RESUME NEXT
        ELSE
          DelTempFiles% = ERR
          EXIT FUNCTION
        END IF
        RESUME NEXT

END FUNCTION

SUB DestroyControl (ControlID%)


  XMSSpaceit VQBStrProp.Handle, StrPropLen&

  FOR y = 0 TO 30
    SetIntProp ControlID, y, 0
    SetIntEvent ControlID, y, 0
  NEXT

  FOR y = 0 TO 15
    SetLongProp ControlID, y, 0
  NEXT

  FOR y = 0 TO 10
    SetLongEvent ControlID, y, 0
  NEXT

END SUB

SUB endGCON

'Deallocate All XMS handles

'DeallocateXMS VQBIntProp.handle
'DeallocateXMS VQBLongProp.handle
DeallocateXMS VQBStrProp.Handle
'DeallocateXMS VQBIntEvent.handle
'DeallocateXMS VQBUnivSwitch.handle

FOR ctr = 0 TO 50
  IF VQBListHandles%(ctr) <> 0 THEN DeallocateXMS VQBListHandles%(ctr)
NEXT

  DeallocateXMS SaveHandle%

  temp = DelTempFiles%

END SUB

FUNCTION FreeListHandle%
FOR ctr = 0 TO UBOUND(VQBListHandles%)
  IF VQBListHandles%(ctr) = 0 THEN FreeListHandle% = ctr: EXIT FOR
NEXT

END FUNCTION

FUNCTION InitGCON% (MaxSave%, XMSMemNeeded&)

  MaxSaveCon% = MaxSave%

  FOR ctr = 1 TO 10
    KeyChar$ = INKEY$
  NEXT


  DblClickSpeed! = .4
  CursorBlinkSpeed! = .3

IntPropLen& = CLNG(LEN(VQBIntProp%)) * CLNG(30) * CLNG(UBOUND(VQBIntProp%))
LongPropLen& = CLNG(LEN(VQBLongProp&)) * CLNG(15) * CLNG(UBOUND(VQBLongProp&))
IntEventLen& = CLNG(LEN(VQBIntEvent%)) * CLNG(30) * CLNG(UBOUND(VQBIntEvent%))
LongEventLen& = CLNG(LEN(VQBLongEvent&)) * CLNG(10) * CLNG(UBOUND(VQBLongEvent&))
UnivLen& = CLNG(LEN(VQBUnivSwitch%)) * CLNG(5) * CLNG(UBOUND(VQBUnivSwitch%))
'StrPropLen& = (VQBStrProp.yIndex * CLNG(VQBStrProp.size)) * CLNG(VQBStrProp.xIndex)
StrPropLen& = 384000

TotalLen& = IntPropLen + LongPropLen + StrPropLen& + IntEventLen + LongEventLen + UnivLen


IntPropPos& = 0
LongPropPos& = IntPropLen
IntEventPos& = LongPropPos& + LongPropLen
LongEventPos& = IntEventPos& + IntEventLen
UnivPos& = LongEventPos& + LongEventLen
StrPropPos& = UnivPos& + UnivLen


IF MaxSave% > 0 THEN
  XMSMemNeeded& = StrPropLen& * CLNG(MaxSave%)
ELSE
  XMSMemNeeded& = StrPropLen&
END IF

  IF FreeXMSmemory < XMSMemNeeded& THEN
    InitGCON% = 1
    EXIT FUNCTION
  END IF

  temp = XMS2D.Allocate(VQBStrProp, 200, 15, 128)

  FOR ctr = 1 TO 150
    XMS2D.PutItem VQBStrProp, ctr, 1, ""
  NEXT

  IF MaxSave% > 0 THEN SaveHandle% = AllocateXMS(StrPropLen& * CLNG(MaxSave%))


END FUNCTION

FUNCTION IntEvent (ControlID%, Index%)
  IntEvent = VQBIntEvent%(ControlID%, Index%)
END FUNCTION

FUNCTION IntProp% (ControlID%, Index%)
  IntProp = VQBIntProp%(ControlID%, Index%)
END FUNCTION

FUNCTION LongEvent& (ControlID%, Index%)
  LongEvent = VQBLongEvent&(ControlID%, Index%)
END FUNCTION

FUNCTION LongProp& (ControlID%, Index%)
  LongProp& = VQBLongProp&(ControlID%, Index%)
END FUNCTION

FUNCTION MouseB%
  MouseB% = VQBMB%
END FUNCTION

FUNCTION MouseX%
  MouseX% = VQBMX%
END FUNCTION

FUNCTION MouseY%
  MouseY% = VQBMY%
END FUNCTION

FUNCTION RestoreControls% (SaveNumber%)
        IF MaxSaveCon% < SaveNumber% + 1 OR SaveNumber% < 0 THEN RestoreControls% = -1: EXIT FUNCTION

        ON LOCAL ERROR GOTO errHandler3


        MoveXMS SaveHandle%, StrPropLen& * CLNG(SaveNumber%), VQBStrProp.Handle, 0, StrPropLen&

        DEF SEG = VARSEG(VQBIntProp(0, 0))
        BLOAD TempDir$ + "INTPR" + LTRIM$(STR$(SaveNumber%)) + ".TMP", VARPTR(VQBIntProp(0, 0))

        DEF SEG = VARSEG(VQBLongProp&(0, 0))
        BLOAD TempDir$ + "LONGP" + LTRIM$(STR$(SaveNumber%)) + ".TMP", VARPTR(VQBLongProp&(0, 0))

        DEF SEG = VARSEG(VQBIntEvent(0, 0))
        BLOAD TempDir$ + "INTEV" + LTRIM$(STR$(SaveNumber%)) + ".TMP", VARPTR(VQBIntEvent(0, 0))

        DEF SEG = VARSEG(VQBLongEvent&(0, 0))
        BLOAD TempDir$ + "LONGE" + LTRIM$(STR$(SaveNumber%)) + ".TMP", VARPTR(VQBLongEvent&(0, 0))

        DEF SEG = VARSEG(VQBUnivSwitch(0, 0))
        BLOAD TempDir$ + "UNIV" + LTRIM$(STR$(SaveNumber%)) + ".TMP", VARPTR(VQBUnivSwitch(0, 0))

        DEF SEG

        EXIT FUNCTION

errHandler3:
                            
        RestoreControls% = ERR
        EXIT FUNCTION

        RESUME NEXT

END FUNCTION

FUNCTION SaveControls% (SaveNumber%)
        IF MaxSaveCon% < SaveNumber% + 1 OR SaveNumber% < 0 THEN SaveControls% = -1: EXIT FUNCTION

        ON LOCAL ERROR GOTO errHandler2
 

        'IntPropPos& = 0
        'LongPropPos& = IntPropLen
        'IntEventPos& = LongPropPos& + LongPropLen
        'LongEventPos& = IntEventPos& + IntEventLen
        'UnivPos& = LongEventPos& + LongEventLen
        'StrPropPos& = UnivPos& + UnivLen
  
        MoveXMS VQBStrProp.Handle, 0, SaveHandle%, StrPropLen& * CLNG(SaveNumber%), StrPropLen&

        DEF SEG = VARSEG(VQBIntProp(0, 0))
        BSAVE TempDir$ + "INTPR" + LTRIM$(STR$(SaveNumber%)) + ".TMP", VARPTR(VQBIntProp(0, 0)), IntPropLen&

        DEF SEG = VARSEG(VQBLongProp&(0, 0))
        BSAVE TempDir$ + "LONGP" + LTRIM$(STR$(SaveNumber%)) + ".TMP", VARPTR(VQBLongProp&(0, 0)), LongPropLen&

        DEF SEG = VARSEG(VQBIntEvent(0, 0))
        BSAVE TempDir$ + "INTEV" + LTRIM$(STR$(SaveNumber%)) + ".TMP", VARPTR(VQBIntEvent(0, 0)), IntEventLen&

        DEF SEG = VARSEG(VQBLongEvent&(0, 0))
        BSAVE TempDir$ + "LONGE" + LTRIM$(STR$(SaveNumber%)) + ".TMP", VARPTR(VQBLongEvent&(0, 0)), LongEventLen&

        DEF SEG = VARSEG(VQBUnivSwitch(0, 0))
        BSAVE TempDir$ + "UNIV" + LTRIM$(STR$(SaveNumber%)) + ".TMP", VARPTR(VQBUnivSwitch(0, 0)), UnivLen&

        DEF SEG
        

        EXIT FUNCTION

errHandler2:
        
        SaveControls% = ERR
        EXIT FUNCTION
        RESUME NEXT

END FUNCTION

SUB SetActiveControl (ControlID%)
  VQBActiveControl% = ControlID%
END SUB

SUB SetBlinkSpeed (Speed!)
  CursorBlinkSpeed! = Speed!
END SUB

SUB SetDblSpeed (Speed!)
  DblClickSpeed! = Speed!
END SUB

SUB SetFocus (ControlID%)
        IF ActiveControl% <> ControlID% THEN 'AND IntProp(ControlID%, 7) = 1 THEN
            SetIntEvent ActiveControl%, 3, 1 'Set lostfocus to active control
            SetIntEvent ControlID%, 2, 1 'Set gotfocus
            SetActiveControl ControlID%
        END IF
END SUB

SUB SetIntEvent (ControlID%, Index%, Value%)
  VQBIntEvent%(ControlID%, Index%) = Value%
END SUB

DEFSNG A-Z
SUB SetIntProp (ControlID%, Index%, Value%)
 ' OPEN "C:\alex" FOR OUTPUT AS 1
  'PRINT #1, controlID%
'  PRINT #1, Index%
'  CLOSE
'  endvqb
'  resetscreen
'  END

  VQBIntProp%(ControlID%, Index%) = Value%
  
END SUB

DEFINT A-Z
SUB SetListHandle (Index%, Value%)
  VQBListHandles(Index%) = Value%
END SUB

SUB SetLongEvent (ControlID%, Index%, Value&)
  VQBLongEvent&(ControlID%, Index%) = Value&
END SUB

SUB SetLongProp (ControlID%, Index%, Value&)
   VQBLongProp&(ControlID%, Index%) = Value&
END SUB

SUB SetStrProp (ControlID%, Index%, Value$)
  temp& = Index%
  XMS2D.PutItem VQBStrProp, ControlID%, temp&, Value$
END SUB

SUB SetTempDir (Value$)
  VQBTempDir$ = Value$
END SUB

DEFSNG A-Z
SUB SetUnivKey (Char$)
  VQBUnivKey$ = Char$
END SUB

DEFINT A-Z
SUB SetUnivSwitch (ControlID%, Index%, Value%)
  VQBUnivSwitch%(ControlID%, Index%) = Value%
END SUB

SUB Short1 (Handle%, itemlen%, Index&, item$, additem%)
IF Handle% = 0 THEN EXIT SUB

SELECT CASE itemlen%
    CASE IS = 32
        XMS32.PutItem Handle%, Index&, item$
        IF additem THEN XMS32.PutItem Handle%, Index& + 1, CHR$(13)
    CASE IS = 64
        XMS64.PutItem Handle%, Index&, item$
        IF additem THEN XMS64.PutItem Handle%, Index& + 1, CHR$(13)
    CASE IS = 128
        XMS128.PutItem Handle%, Index&, item$
        IF additem THEN XMS128.PutItem Handle%, Index& + 1, CHR$(13)
    CASE IS = 256
        XMS256.PutItem Handle%, Index&, item$
        IF additem THEN XMS256.PutItem Handle%, Index& + 1, CHR$(13)
    CASE IS = 512
        XMS512.PutItem Handle%, Index&, item$
        IF additem THEN XMS512.PutItem Handle%, Index& + 1, CHR$(13)
  END SELECT

END SUB

SUB Short2 (Handle%, itemlen%, Index&, CompItems&)
IF Handle% = 0 THEN EXIT SUB

SELECT CASE itemlen%
    CASE IS = 32
        XMS32.PutItem Handle%, Index&, item$
        IF additem THEN XMS32.PutItem Handle%, Index& + 1, ""
    CASE IS = 64
        XMS64.PutItem Handle%, Index&, item$
        IF additem THEN XMS64.PutItem Handle%, Index& + 1, ""
    CASE IS = 128
        XMS128.PutItem Handle%, Index&, item$
        IF additem THEN XMS128.PutItem Handle%, Index& + 1, ""
    CASE IS = 256
        XMS256.PutItem Handle%, Index&, item$
        IF additem THEN XMS256.PutItem Handle%, Index& + 1, ""
    CASE IS = 512
        XMS512.PutItem Handle%, Index&, item$
        IF additem THEN XMS512.PutItem Handle%, Index& + 1, ""
  END SELECT



END SUB

FUNCTION StrProp$ (ControlID%, Index%)
  temp& = Index%
  StrProp$ = XMS2D.GetItem(VQBStrProp, ControlID%, temp&)
END FUNCTION

FUNCTION TempDir$
  TempDir$ = VQBTempDir$
END FUNCTION

DEFSNG A-Z
FUNCTION UnivKey$
    UnivKey$ = VQBUnivKey$
END FUNCTION

DEFINT A-Z
FUNCTION UnivSwitch% (ControlID%, Index%)
  UnivSwitch% = VQBUnivSwitch%(ControlID%, Index%)
END FUNCTION

DEFSNG A-Z
SUB Updatekey
  IF MouseB = 0 THEN VQBUnivKey$ = INKEY$
END SUB

SUB UpdateMouse
  Future.updatemouse
  VQBMY% = Future.MouseY
  VQBMX% = Future.MouseX
  VQBMB% = Future.MouseB
END SUB

DEFINT A-Z
SUB XMS.DeleteItem (Handle%, itemlen%, Index&, CompItems&)
 IF Handle% = 0 THEN EXIT SUB

 offs& = CLNG(itemlen) * Index&

 MoveXMS Handle, offs& + CLNG(itemlen), Handle, offs&, CLNG(itemlen) * CompItems&
  

END SUB

SUB XMS.InsertItem (Handle%, itemlen%, Index&, item$, TotalItems&)
 IF Handle% = 0 THEN EXIT SUB

 tempHandle = AllocateXMS(CLNG(itemlen) * TotalItems&)
                                               
 offs& = CLNG(itemlen) * Index&
 MoveXMS Handle, offs&, tempHandle, 0, CLNG(itemlen) * TotalItems&
 MoveXMS tempHandle, 0, Handle, offs& + CLNG(itemlen), CLNG(itemlen) * TotalItems&
 

SELECT CASE itemlen%
    CASE IS = 32
        XMS32.PutItem Handle%, Index&, item$
        'IF additem THEN XMS32.PutItem handle%, Index& + 1, CHR$(13)
    CASE IS = 64
        XMS64.PutItem Handle%, Index&, item$
        'IF additem THEN XMS64.PutItem handle%, Index& + 1, CHR$(13)
    CASE IS = 128
        XMS128.PutItem Handle%, Index&, item$
        'IF additem THEN XMS128.PutItem handle%, Index& + 1, CHR$(13)
    CASE IS = 256
        XMS256.PutItem Handle%, Index&, item$
        'IF additem THEN XMS256.PutItem handle%, Index& + 1, CHR$(13)
    CASE IS = 512
        XMS512.PutItem Handle%, Index&, item$
        'IF additem THEN XMS512.PutItem handle%, Index& + 1, CHR$(13)
  END SELECT

  DeallocateXMS tempHandle%

END SUB

FUNCTION XMS128.GetItem$ (Handle%, Index&)
  DIM temp AS STRING * 128

  offs& = CLNG(128) * Index&

  MoveFromXMS Handle%, VARSEG(temp), VARPTR(temp), 128, offs&

  XMS128.GetItem$ = RTRIM$(temp)

END FUNCTION

SUB XMS128.PutItem (Handle%, Index&, charstr$)
 DIM temp AS STRING * 128

 temp = charstr$

 offs& = CLNG(128) * Index&

 MoveToXMS Handle%, VARSEG(temp), VARPTR(temp), 128, offs&

END SUB

FUNCTION XMS128.Ubound& (AllocatedSize&)
  XMS128.Ubound& = AllocatedSize& / 128
END FUNCTION

FUNCTION XMS256.GetItem$ (Handle%, Index&)
  DIM temp AS STRING * 256

  offs& = CLNG(256) * Index&

  MoveFromXMS Handle%, VARSEG(temp), VARPTR(temp), 256, offs&

  XMS256.GetItem$ = RTRIM$(temp)
  
END FUNCTION

SUB XMS256.PutItem (Handle%, Index&, charstr$)
 DIM temp AS STRING * 256
 
 temp = charstr$

 offs& = CLNG(256) * Index&

 MoveToXMS Handle%, VARSEG(temp), VARPTR(temp), 256, offs&

END SUB

FUNCTION XMS256.Ubound& (AllocatedSize&)
  XMS256.Ubound& = AllocatedSize& / 256
END FUNCTION

FUNCTION XMS2D.Allocate% (Handle AS XMS2D, xIndex%, yIndex&, size%)

  TotalBytes& = XMS2D.GetSize(xIndex%, yIndex&, size%)

  Handle.xIndex = xIndex%
  Handle.yIndex = yIndex&
  Handle.xIndextotal = yIndex& * CLNG(size%)
  
  Handle.size = size%

  Handle.Handle = AllocateXMS(TotalBytes&)

  XMSSpaceit Handle.Handle, TotalBytes&

  XMS2D.Allocate% = Handle.Handle
  
END FUNCTION

FUNCTION XMS2D.GetItem$ (Handle AS XMS2D, xIndex%, yIndex&)
  IF xIndex% > Handle.xIndex OR yIndex& > Handle.yIndex THEN EXIT FUNCTION

  DIM str2 AS STRING * 2, str4 AS STRING * 4, str8 AS STRING * 8, str16 AS STRING * 16
  DIM str32 AS STRING * 32, str64 AS STRING * 64, str128 AS STRING * 128
  DIM str256 AS STRING * 256, str512 AS STRING * 512

  'temp = a$
  'PRINT ((handle.xtotal) * CLNG(itemn)) - handle.xtotal + CLNG(1) + (subitem& * CLNG(handle.size)) - CLNG(handle.size)
  'MID$(dummy, ((handle.xIndextotal) * CLNG(itemn)) - handle.xIndextotal + CLNG(1) + (subitem& * CLNG(handle.size)) - CLNG(handle.size), handle.size) = temp

 offs& = ((Handle.xIndextotal) * CLNG(xIndex%)) - Handle.xIndextotal + CLNG(1) + (yIndex& * CLNG(Handle.size)) - CLNG(Handle.size) - 1

 SELECT CASE Handle.size
   CASE IS = 2
     MoveFromXMS Handle.Handle, VARSEG(str2), VARPTR(str2), 2, offs&
     tempVal$ = RTRIM$(str2)
   CASE IS = 4
     MoveFromXMS Handle.Handle, VARSEG(str4), VARPTR(str4), 4, offs&
     tempVal$ = RTRIM$(str4)
   CASE IS = 8
     MoveFromXMS Handle.Handle, VARSEG(str8), VARPTR(str8), 8, offs&
     tempVal$ = RTRIM$(str8)
   CASE IS = 16
     MoveFromXMS Handle.Handle, VARSEG(str16), VARPTR(str16), 16, offs&
     tempVal$ = RTRIM$(str16)
   CASE IS = 32
     MoveFromXMS Handle.Handle, VARSEG(str32), VARPTR(str32), 32, offs&
     tempVal$ = RTRIM$(str32)
   CASE IS = 64
     MoveFromXMS Handle.Handle, VARSEG(str64), VARPTR(str64), 64, offs&
     tempVal$ = RTRIM$(str64)
   CASE IS = 128
     MoveFromXMS Handle.Handle, VARSEG(str128), VARPTR(str128), 128, offs&
     tempVal$ = RTRIM$(str128)
   CASE IS = 256
     MoveFromXMS Handle.Handle, VARSEG(str256), VARPTR(str256), 256, offs&
     tempVal$ = RTRIM$(str256)
   CASE IS = 512
     MoveFromXMS Handle.Handle, VARSEG(str512), VARPTR(str512), 512, offs&
     tempVal$ = RTRIM$(str512)

 END SELECT

 XMS2D.GetItem = tempVal$

END FUNCTION

FUNCTION XMS2D.GetSize& (xIndex%, yIndex&, size%)

  XMS2D.GetSize& = (yIndex& * CLNG(size%)) * CLNG(xIndex%)

END FUNCTION

SUB XMS2D.PutItem (Handle AS XMS2D, xIndex%, yIndex&, charstr$)

  IF xIndex% > Handle.xIndex OR yIndex& > Handle.yIndex THEN EXIT SUB

  DIM str2 AS STRING * 2, str4 AS STRING * 4, str8 AS STRING * 8, str16 AS STRING * 16
  DIM str32 AS STRING * 32, str64 AS STRING * 64, str128 AS STRING * 128
  DIM str256 AS STRING * 256, str512 AS STRING * 512

 offs& = ((Handle.xIndextotal) * CLNG(xIndex%)) - Handle.xIndextotal + CLNG(1) + (yIndex& * CLNG(Handle.size)) - CLNG(Handle.size) - 1

 SELECT CASE Handle.size
   CASE IS = 2
     str2 = charstr$
     MoveToXMS Handle.Handle, VARSEG(str2), VARPTR(str2), 2, offs&
   CASE IS = 4
     str4 = charstr$
     MoveToXMS Handle.Handle, VARSEG(str4), VARPTR(str4), 4, offs&
   CASE IS = 8
     str8 = charstr$
     MoveToXMS Handle.Handle, VARSEG(str8), VARPTR(str8), 8, offs&
   CASE IS = 16
     str16 = charstr$
     MoveToXMS Handle.Handle, VARSEG(str16), VARPTR(str16), 16, offs&
   CASE IS = 32
     str32 = charstr$
     MoveToXMS Handle.Handle, VARSEG(str32), VARPTR(str32), 32, offs&
   CASE IS = 64
      str64 = charstr$
      MoveToXMS Handle.Handle, VARSEG(str64), VARPTR(str64), 64, offs&
   CASE IS = 128
      str128 = charstr$
      MoveToXMS Handle.Handle, VARSEG(str128), VARPTR(str128), 128, offs&
   CASE IS = 256
      str256 = charstr$
      MoveToXMS Handle.Handle, VARSEG(str256), VARPTR(str256), 256, offs&
   CASE IS = 512
      str512 = charstr$
      MoveToXMS Handle.Handle, VARSEG(str512), VARPTR(str512), 512, offs&

 END SELECT

END SUB

FUNCTION XMS32.GetItem$ (Handle%, Index&)

  DIM temp AS STRING * 32

  offs& = CLNG(32) * Index&

  MoveFromXMS Handle%, VARSEG(temp), VARPTR(temp), 32, offs&

  XMS32.GetItem$ = RTRIM$(temp)

END FUNCTION

SUB XMS32.PutItem (Handle%, Index&, charstr$)
 DIM temp AS STRING * 32

 temp = charstr$

 offs& = CLNG(32) * Index&

 MoveToXMS Handle%, VARSEG(temp), VARPTR(temp), 32, offs&

END SUB

FUNCTION XMS32.Ubound& (AllocatedSize&)
  XMS32.Ubound& = AllocatedSize& / 32
END FUNCTION

FUNCTION XMS4.GetItem$ (Handle%, Index&)

  DIM temp AS STRING * 4

  offs& = CLNG(4) * Index&

  MoveFromXMS Handle%, VARSEG(temp), VARPTR(temp), 4, offs&

  XMS2.GetItem$ = RTRIM$(temp)

END FUNCTION

SUB XMS4.PutItem (Handle%, Index&, charstr$)
 DIM temp AS STRING * 4

 temp = charstr$

 offs& = CLNG(4) * Index&

 MoveToXMS Handle%, VARSEG(temp), VARPTR(temp), 4, offs&

END SUB

FUNCTION XMS4.Ubound& (AllocatedSize&)
  XMS4.Ubound& = AllocatedSize& / 4
END FUNCTION

FUNCTION XMS512.GetItem$ (Handle%, Index&)
  DIM temp AS STRING * 512

  offs& = CLNG(512) * Index&

  MoveFromXMS Handle%, VARSEG(temp), VARPTR(temp), 512, offs&

  XMS512.GetItem$ = RTRIM$(temp)

END FUNCTION

SUB XMS512.PutItem (Handle%, Index&, charstr$)
 DIM temp AS STRING * 512

 temp = charstr$

 offs& = CLNG(512) * Index&

 MoveToXMS Handle%, VARSEG(temp), VARPTR(temp), 512, offs&

END SUB

FUNCTION XMS512.Ubound& (AllocatedSize&)
  XMS512.Ubound& = AllocatedSize& / 512
END FUNCTION

FUNCTION XMS64.GetItem$ (Handle%, Index&)
  DIM temp AS STRING * 64

  offs& = CLNG(64) * Index&

  MoveFromXMS Handle%, VARSEG(temp), VARPTR(temp), 64, offs&

  XMS64.GetItem$ = RTRIM$(temp)

END FUNCTION

SUB XMS64.PutItem (Handle%, Index&, charstr$)
 DIM temp AS STRING * 64

 temp = charstr$

 offs& = CLNG(64) * Index&

 MoveToXMS Handle%, VARSEG(temp), VARPTR(temp), 64, offs&

END SUB

FUNCTION XMS64.Ubound& (AllocatedSize&)
  XMS64.Ubound& = AllocatedSize& / 64
END FUNCTION

SUB XMSSpaceit (Handle%, TotalBytes&)
  'remain& = TotalBytes& / CLNG(2000)
  DIM temp AS STRING * 2000

  temp = SPACE$(2000)
  offs& = 0
  DO
    MoveToXMS Handle, VARSEG(temp), VARPTR(temp), 2000, offs&
    offs& = offs& + 2000
  LOOP UNTIL offs& > TotalBytes&
  MoveToXMS Handle, VARSEG(temp), VARPTR(temp), 2000, offs&

END SUB

