'$INCLUDE: 'gcontrol.bi'


CLS
IF IsXMSInstalled <> -1 THEN PRINT "No XMS": END        'check if XMS is installed
IF IsEMMInstalled <> -1 THEN PRINT "No EMS": END        'check if EMS is installed

Set800x600 16
'Set320x200 24
'Set640x480 16

temp = InitGCON%(0, mem&)               'Initializes G-Control with no controls saving

IF temp = 1 THEN        'InitGCON returns 1  = insufficient XMS memory
  resetscreen
  PRINT "Insufficient XMS memory."
  END
END IF


future.mouseoff
future.fillbox 0, 0, 800, 600, RGB2Color(200, 200, 200)
future.mouseon

vscr1 = VScroll.Create(20, 20, 300, 0, RGB2Color(200, 200, 200))
vscr2 = VScroll.Create(100, 20, 300, 0, RGB2Color(200, 200, 200))
vscr3 = VScroll.Create(180, 20, 300, 0, RGB2Color(200, 200, 200))


hscr1 = HScroll.Create(320, 20, 300, 0, RGB2Color(200, 200, 200))
hscr2 = HScroll.Create(320, 90, 300, 0, RGB2Color(200, 200, 200))
hscr3 = HScroll.Create(320, 160, 300, 0, RGB2Color(200, 200, 200))


cmdSetMaxTo100 = Button.Create("Set MaxValue to 100", 20, 370, 220, 30, 0, RGB2Color(255, 255, 255))
cmdSetMaxTo1000 = Button.Create("Set MaxValue to 1000", 250, 370, 220, 30, 0, RGB2Color(255, 255, 255))
cmdSetMaxTo10000 = Button.Create("Set MaxValue to 10000", 480, 370, 220, 30, 0, RGB2Color(255, 255, 255))

cmdSetValTo100 = Button.Create("Set Value to 100", 20, 420, 220, 30, 0, RGB2Color(255, 255, 255))
cmdSetValTo1000 = Button.Create("Set Value to 1000", 250, 420, 220, 30, 0, RGB2Color(255, 255, 255))
cmdSetValTo10000 = Button.Create("Set Value to 10000", 480, 420, 220, 30, 0, RGB2Color(255, 255, 255))


DO
  Updatekey
  UpdateMouse

  IF VScroll.Change(vscr1) THEN
        future.print 20, 340, LTRIM$(STR$(VScroll.Value(vscr1))) + "   ", 0, RGB2Color(200, 200, 200)
  END IF
  VScroll.DoEvent vscr1

  IF VScroll.Change(vscr2) THEN
        future.print 100, 340, LTRIM$(STR$(VScroll.Value(vscr2))) + "   ", 0, RGB2Color(200, 200, 200)
  END IF
  VScroll.DoEvent vscr2

  IF VScroll.Change(vscr3) THEN
        future.print 180, 340, LTRIM$(STR$(VScroll.Value(vscr3))) + "   ", 0, RGB2Color(200, 200, 200)
  END IF
  VScroll.DoEvent vscr3

  IF HScroll.Change(hscr1) THEN
        future.print 640, 20, LTRIM$(STR$(HScroll.Value(hscr1))) + "   ", 0, RGB2Color(200, 200, 200)
  END IF
  HScroll.DoEvent hscr1

  IF HScroll.Change(hscr2) THEN
        future.print 640, 90, LTRIM$(STR$(HScroll.Value(hscr2))) + "   ", 0, RGB2Color(200, 200, 200)
  END IF
  HScroll.DoEvent hscr2

  IF HScroll.Change(hscr3) THEN
        future.print 640, 160, LTRIM$(STR$(HScroll.Value(hscr3))) + "   ", 0, RGB2Color(200, 200, 200)
  END IF
  HScroll.DoEvent hscr3


  IF Button.click(cmdSetMaxTo100) THEN
    Max& = 100
    GOSUB SetMax
  END IF
  Button.DoEvent cmdSetMaxTo100

  IF Button.click(cmdSetMaxTo1000) THEN
    Max& = 1000
    GOSUB SetMax
  END IF
  Button.DoEvent cmdSetMaxTo1000

  IF Button.click(cmdSetMaxTo10000) THEN
    Max& = 10000
    GOSUB SetMax
  END IF
  Button.DoEvent cmdSetMaxTo10000


  IF Button.click(cmdSetValTo100) THEN
    Value& = 100
    GOSUB SetValue
  END IF
  Button.DoEvent cmdSetValTo100

  IF Button.click(cmdSetValTo1000) THEN
    Value& = 1000
    GOSUB SetValue
  END IF
  Button.DoEvent cmdSetValTo1000

  IF Button.click(cmdSetValTo10000) THEN
    Value& = 10000
    GOSUB SetValue
  END IF
  Button.DoEvent cmdSetValTo10000

LOOP UNTIL UnivKey = CHR$(27)   'Press ESC to end program
                                'Use UnivKey instead of INKEY$

resetscreen     'reset screen to previous mode
endGCON         'extremely important when you end your program

END

SetMax:


    VScroll.SetMaxValue vscr1, Max&
    VScroll.SetMaxValue vscr2, Max&
    VScroll.SetMaxValue vscr3, Max&

    HScroll.SetMaxValue hscr1, Max&
    HScroll.SetMaxValue hscr2, Max&
    HScroll.SetMaxValue hscr3, Max&

    RETURN

SetValue:

    VScroll.SetValue vscr1, Value&
    VScroll.SetValue vscr2, Value&
    VScroll.SetValue vscr3, Value&

    HScroll.SetValue hscr1, Value&
    HScroll.SetValue hscr2, Value&
    HScroll.SetValue hscr3, Value&



    RETURN

